Localization Classic Report Designer

Localization is the process of customizing the application for a given culture and locale - involving much more than the simple translation of text. In classic web report designer, localized strings appropriate to each culture are stored in separate files and loaded according to the UI culture setting.

This section explains steps to localize Bold Reports® Designer version less than v5.2.xx.

By default classic report designer display strings in US English(en-US).

To render the static text with specific culture, refer the following corresponding culture script files and set culture name to the locale property of the classic Report Designer.

  • ej.localetexts.fr-FR.min.js
  • ej.culture.fr-FR.min.js

Refer the ej.localetexts.fr-FR.min.js and ej.culture.fr-FR.min.js scripts from cdn using the following code in <head> tag of the Report Designer HTML page.

<script src="https://cdn.boldreports.com/13.1.26/scripts/l10n/reportdesigner/ej.localetexts.fr-FR.min.js"></script>
<script src="https://cdn.boldreports.com/13.1.26/scripts/i18n/ej.culture.fr-FR.min.js"></script>

Whether you want to get the localization script as local then install the BoldReports.Global NuGet package in your application.

<script src="scripts/l10n/ej.localetexts.fr-FR.min.js"></script>
<script src="scripts/i18n/ej.culture.fr-FR.min.js"></script>

You can edit and preview the classic Report Designer localization using the following.

index.html
index.js
ReportingAPIController.cs
    <body style="overflow: hidden; position: static; margin: 0; padding: 0; height: 100%; width: 100%;">
        <div id="designer" style="position: absolute; height: 100%; width: 100%;"></div>
        <script src="index.js"></script>
    </body>
    $(function () {
        $("#designer").boldReportDesigner({
         serviceUrl: "https://demos.boldreports.com/services/api/ReportingAPI",
         locale: "fr-FR"
        });
    });
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using BoldReports.Web;
using BoldReports.Web.ReportViewer;
using BoldReports.Web.ReportDesigner;

namespace ReportDesignerAPIService
{
    [System.Web.Http.Cors.EnableCors(origins: "*", headers: "*", methods: "*")]
    public class ReportingAPIController : ApiController, IReportDesignerController
    {
        /// <summary>
        /// Get the path of specific file
        /// </summary>
        /// <param name="itemName">Name of the file to get the full path</param>
        /// <param name="key">The unique key for report designer.</param>
        /// <returns>Returns the full path of file</returns>
        [NonAction]
        private string GetFilePath(string itemName, string key)
        {
            string rootPath = this._hostingEnvironment.WebRootPath ? this._hostingEnvironment.WebRootPath : this._hostingEnvironment.ContentRootPath;
            string dirPath = Path.Combine(rootPath, "Cache", key);

            if (!System.IO.Directory.Exists(dirPath))
            {
                System.IO.Directory.CreateDirectory(dirPath);
            }

            return Path.Combine(dirPath, itemName);
        }

        /// <summary>
        /// Action (HttpGet) method for getting resource of images in the report.
        /// </summary>
        /// <param name="key">The unique key for request identification.</param>
        /// <param name="image">The name of requested image.</param>
        /// <returns>Returns the image as HttpResponseMessage content.</returns>
        [System.Web.Http.ActionName("GetImage")]
        [AcceptVerbs("GET")]
        public object GetImage(string key, string image)
        {
            return ReportDesignerHelper.GetImage(key, image, this);
        }

        /// <summary>
        /// Action (HttpPost) method for posting the request for designer actions.
        /// </summary>
        /// <param name="jsonData">A collection of keys and values to process the designer request.</param>
        /// <returns>Json result for the current request.</returns>
        public object PostDesignerAction(Dictionary<string, object> jsonData)
        {
            //Processes the designer request and returns the result.
            return ReportDesignerHelper.ProcessDesigner(jsonData, this, null);
        }

        /// <summary>
        /// Sets the resource into storage location.
        /// </summary>
        /// <param name="key">The unique key for request identification.</param>
        /// <param name="itemId">The unique key to get the required resource.</param>
        /// <param name="itemData">Contains the resource data.</param>
        /// <param name="errorMessage">Returns the error message, if the write action is failed.</param>
        /// <returns>Returns true, if resource is successfully written into storage location.</returns>
        [NonAction]
        public bool SetData(string key, string itemId, ItemInfo itemData, out string errorMessage)
        {
            errorMessage = string.Empty;

            if (itemData.Data != null)
            {
                File.WriteAllBytes(this.GetFilePath(itemId, key), itemData.Data);
            }
            else if (itemData.PostedFile != null)
            {
                var fileName = itemId;
                if (string.IsNullOrEmpty(itemId))
                {
                    fileName = Path.GetFileName(itemData.PostedFile.FileName);
                }
                itemData.PostedFile.SaveAs(this.GetFilePath(fileName, key));
            }

            return true;
        }

        /// <summary>
        /// Gets the resource from storage location.
        /// </summary>
        /// <param name="key">The unique key for request identification.</param>
        /// <param name="itemId">The unique key to get the required resource.</param>
        ///  <returns>Returns the resource data and error message.</returns>
        [NonAction]
        public ResourceInfo GetData(string key, string itemId)
        {
            var resource = new ResourceInfo();
            try
            {
                var filePath = this.GetFilePath(itemId, key);
                if (itemId.Equals(Path.GetFileName(filePath), StringComparison.InvariantCultureIgnoreCase) && File.Exists(filePath))
                {
                    resource.Data = System.IO.File.ReadAllBytes(filePath);
                }
                else
                {
                    resource.ErrorMessage = "File not found from the specified path";
                }
            }
            catch (Exception ex)
            {
                resource.ErrorMessage = ex.Message;
            }
            return resource;
        }

        /// <summary>
        /// Action (HttpPost) method for posted or uploaded file actions.
        /// </summary>
        public void UploadReportAction()
        {
            //Processes the designer file upload request's.
            ReportDesignerHelper.ProcessDesigner(null, this, System.Web.HttpContext.Current.Request.Files[0]);
        }

        /// <summary>
        /// Send a GET request and returns the requested resource for a report.
        /// </summary>
        /// <param name="key">The unique key to get the desired resource.</param>
        /// <param name="resourcetype">The type of the requested resource.</param>
        /// <param name="isPrint">If set to <see langword="true"/>, then the resource is generated for printing.</param>
        /// <returns> Resource object for the given key</returns>
        [System.Web.Http.ActionName("GetResource")]
        [AcceptVerbs("GET")]
        public object GetResource(string key, string resourcetype, bool isPrint)
        {
            return ReportHelper.GetResource(key, resourcetype, isPrint);
        }

        /// <summary>
        /// Report Initialization method that is triggered when report begin processed.
        /// </summary>
        /// <param name="reportOptions">The ReportViewer options.</param>
        [NonAction]
        public void OnInitReportOptions(ReportViewerOptions reportOption)
        {
            var resourcesPath = System.Web.Hosting.HostingEnvironment.MapPath("~/Scripts");

            reportOption.ReportModel.ExportResources.Scripts = new List<string>
            {
                resourcesPath + @"\bold-reports\common\bold.reports.common.min.js",
                resourcesPath + @"\bold-reports\common\bold.reports.widgets.min.js",
                //Gauge component scripts
                resourcesPath + @"\bold-reports\common\ej2-base.min.js",
                resourcesPath + @"\bold-reports\common\ej2-data.min.js",
                resourcesPath + @"\bold-reports\common\ej2-pdf-export.min.js",
                resourcesPath + @"\bold-reports\common\ej2-svg-base.min.js",
                resourcesPath + @"\bold-reports\data-visualization\ej2-lineargauge.min.js",
                resourcesPath + @"\bold-reports\data-visualization\ej2-circulargauge.min.js",
                //Map component script
                resourcesPath + @"\bold-reports\data-visualization\ej2-maps.min.js",
                //Report viewer Script
                resourcesPath + @"\bold-reports\data-visualization\ej.chart.min.js",
                resourcesPath + @"\bold-reports\bold.report-viewer.min.js"
            };

            reportOption.ReportModel.ExportResources.DependentScripts = new List<string>
            {
                resourcesPath + @"\jquery-1.7.1.min.js"
            };
        }

        /// <summary>
        /// Report loaded method that is triggered when report and sub report begins to be loaded.
        /// </summary>
        /// <param name="reportOptions">The ReportViewer options.</param>
        [NonAction]
        public void OnReportLoaded(ReportViewerOptions reportOption)
        {
            //You can update report options here
        }

        /// <summary>
        /// Action (HttpPost) method for posting the request for report process.
        /// </summary>
        /// <param name="jsonData">The JSON data posted for processing report.</param>
        /// <returns>The object data.</returns>
        public object PostReportAction(Dictionary<string, object> jsonData)
        {
            //Processes the report request and returns the result.
            return ReportHelper.ProcessReport(jsonData, this as IReportController);
        }
    }
}

Localization

Localization is the process of customizing the application for a given culture and locale - involving much more than the simple translation of text. In web report designer, localized strings appropriate to each culture are stored in separate files and loaded according to the UI culture setting.

This section explains steps to localize Bold Reports® Designer version less than v5.2.xx.

By default report designer display strings in US English(en-US).

To render the static text with specific culture, refer the following corresponding culture script files and set culture name to the locale property of the Report Designer.

  • ej.localetexts.fr-FR.min.js
  • ej.culture.fr-FR.min.js
  • Run the below command, to install the @boldreports/global package

    npm install @boldreports/global --save
  • Refer the ej.localetexts.fr-FR.min.js and ej.culture.fr-FR.min.js from node_modules in app.module.ts file .

    import { BrowserModule } from '@angular/platform-browser';
    import { NgModule } from '@angular/core';
    import { BoldReportsModule } from '@boldreports/angular-reporting-components';
    
    import '@boldreports/javascript-reporting-controls/Scripts/bold.report-viewer.min';
    import '@boldreports/javascript-reporting-controls/Scripts/bold.report-designer.min';
    
    import '@boldreports/global/l10n/reportdesigner/ej.localetexts.fr-FR.min.js';
    import '@boldreports/global/i18n/ej.culture.fr-FR.min.js';
    import { AppRoutingModule } from './app-routing.module';
    import { AppComponent } from './app.component';
    
    @NgModule({
      declarations: [
        AppComponent
      ],
      imports: [
        BrowserModule,
        BoldReportsModule,
        AppRoutingModule
      ],
      providers: [],
      bootstrap: [AppComponent]
    })
    export class AppModule { }
    

    If we import the culture before the @boldreports/angular-reporting-components package, we get the following error in our application. So, we should import the culture after the @boldreports/angular-reporting-components package.

    Angular culture error

  • Open the src/app/app.component.ts and initialize the locale for Report Designer.

    import { Component } from '@angular/core';
    
    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {
        public serviceUrl: string;
        public locale: string;
    
        constructor() {
            this.serviceUrl = "https://demos.boldreports.com/services/api/ReportingAPI";
            this.locale = "fr-FR";
        }
    }
  • Open the src/app/app.component.html file and assign the locale for Report Designer.

    <bold-reportdesigner id="designer" style="position: absolute;height: 550px; width: 1250px;" [serviceUrl] = "serviceUrl" [locale]= "locale"></bold-reportdesigner>

Localization

Localization is the process of customizing the application for a given culture and locale - involving much more than the simple translation of text. In web report designer, localized strings appropriate to each culture are stored in separate files and loaded according to the UI culture setting.

This section explains steps to localize Bold Reports® Designer version less than v5.2.xx

By default classic report designer display strings in US English(en-US).

To render the static text with specific culture, refer the following corresponding culture script files and set culture name to the locale property of the classic Report Designer.

  • ej.localetexts.fr-FR.min.js
  • ej.culture.fr-FR.min.js
  1. Run the below command, to install the @boldreports/global package

    npm install @boldreports/global --save
  2. Refer the ej.localetexts.fr-FR.min.js and ej.culture.fr-FR.min.js from node_modules in App.js or App.tsx file.

    import React from 'react';
    import './App.css';
    //Report designer source
    import '@boldreports/javascript-reporting-controls/Scripts/bold.report-designer.min';
    import '@boldreports/javascript-reporting-controls/Scripts/bold.report-viewer.min';
    import '@boldreports/javascript-reporting-controls/Content/material/bold.reports.all.min.css';
    import '@boldreports/javascript-reporting-controls/Content/material/bold.reportdesigner.min.css';
    //Data-Visualization
    import '@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej.bulletgraph.min';
    import '@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej.chart.min';
    import '@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej2-circulargauge.min';
    import '@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej2-lineargauge.min';
    import '@boldreports/javascript-reporting-controls/Scripts/data-visualization/ej2-maps.min';
    //Reports react base
    import '@boldreports/react-reporting-components/Scripts/bold.reports.react.min';
    import '@boldreports/global/l10n/reportdesigner/ej.localetexts.fr-FR.min.js';
    import '@boldreports/global/i18n/ej.culture.fr-FR.min.js';
    
    declare let BoldReportDesignerComponent: any;
    
    var designerStyle = {
      'height': '700px',
      'width': '100%'
    };
    
    function App() {
      return (
        <div style={designerStyle}>
        <BoldReportDesignerComponent
        id="reportdesigner_container"
        serviceUrl={'https://demos.boldreports.com/services/api/ReportingAPI'}
        >
        </BoldReportDesignerComponent>
        </div>
      );
    }
    
    export default App;
    
  3. Open the App.js or App.tsx and assign the locale for classic Report Designer.

    function App() {
      return (
        <div style={designerStyle}>
        <BoldReportDesignerComponent
        id="reportdesigner_container"
        serviceUrl={'https://demos.boldreports.com/services/api/ReportingAPI'}
        locale="fr-FR">
        </BoldReportDesignerComponent>
        </div>
      );
    }